var _excluded = ["detail", "leftSpan", "rightSpan", "gutter", "style", "pagination", "header", "footer", "renderItem", "onRowClick", "paginationType", "listGap", "loadMoreData", "listHeight", "pcDetailModalDisplay", "padDetailModalDisplay", "mobilePadDetailModalDisplay", "children", "locale", "emptyButtons"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useCallback, useMemo, useState } from "react";
import { Button, Col, Empty, List, Row, Skeleton, Space } from "antd";
import { getUniqueId } from "@pisell/utils";
import Pagination from "../Pagination";
import { CloseOutlined } from "@ant-design/icons";
import InfiniteScroll from "react-infinite-scroll-component";
import { useResponsive } from "../../hooks";
import "./index.less";
var prefix = "pisell-lowcode-";
var RecordView = function RecordView(props) {
  var detail = props.detail,
    leftSpan = props.leftSpan,
    rightSpan = props.rightSpan,
    gutter = props.gutter,
    style = props.style,
    pagination = props.pagination,
    header = props.header,
    footer = props.footer,
    renderItem = props.renderItem,
    onRowClick = props.onRowClick,
    paginationType = props.paginationType,
    listGap = props.listGap,
    loadMoreData = props.loadMoreData,
    listHeight = props.listHeight,
    pcDetailModalDisplay = props.pcDetailModalDisplay,
    padDetailModalDisplay = props.padDetailModalDisplay,
    mobilePadDetailModalDisplay = props.mobilePadDetailModalDisplay,
    children = props.children,
    locale = props.locale,
    _props$emptyButtons = props.emptyButtons,
    emptyButtons = _props$emptyButtons === void 0 ? [] : _props$emptyButtons,
    others = _objectWithoutProperties(props, _excluded);
  var responsive = useResponsive();
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    detailModalShow = _useState2[0],
    setDetailModalShow = _useState2[1];
  var detailModalDisplay = useMemo(function () {
    if (responsive === "pc") {
      return pcDetailModalDisplay;
    } else if (responsive === "ipad") {
      return padDetailModalDisplay;
    } else if (responsive === "phone") {
      return mobilePadDetailModalDisplay;
    }
  }, [responsive, pcDetailModalDisplay, padDetailModalDisplay, mobilePadDetailModalDisplay]);
  var _footer = useMemo(function () {
    if (!(pagination && paginationType === "default") && !footer) {
      return null;
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, pagination && paginationType === "default" && /*#__PURE__*/React.createElement(Pagination, _extends({
      showLessItems: true
    }, pagination)), footer);
  }, [pagination, footer]);
  var _renderItem = useCallback(function (item) {
    return /*#__PURE__*/React.createElement("div", {
      onClick: function onClick() {
        setDetailModalShow(true);
        onRowClick(item);
      },
      style: {
        marginBottom: listGap
      }
    }, renderItem(item));
  }, [renderItem]);
  var _leftSpan = useMemo(function () {
    if (detailModalDisplay) {
      return 24;
    }
    return leftSpan;
  }, [leftSpan, detailModalDisplay]);
  var emptyDom = useMemo(function () {
    if (props.dataSource.length > 0) {
      return null;
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Empty, {
      description: locale === null || locale === void 0 ? void 0 : locale.emptyText,
      image: Empty.PRESENTED_IMAGE_SIMPLE
    }), !!emptyButtons.length && /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefix, "empty-button")
    }, /*#__PURE__*/React.createElement(Space, null, emptyButtons.map(function (item) {
      return /*#__PURE__*/React.createElement(Button, item);
    }))));
  }, [props.dataSource, locale, emptyButtons]);
  var scrollListId = useMemo(function () {
    return "scrollableDiv-".concat(getUniqueId());
  }, []);
  var list = useMemo(function () {
    if (paginationType === "scroll") {
      return /*#__PURE__*/React.createElement("div", null, header && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "scroll-header-wrap")
      }, header), /*#__PURE__*/React.createElement("div", {
        id: scrollListId,
        style: {
          height: listHeight || 400,
          overflow: "auto"
        }
      }, /*#__PURE__*/React.createElement(InfiniteScroll, {
        dataLength: props.dataSource.length,
        next: loadMoreData,
        hasMore: props.dataSource.length < ((pagination === null || pagination === void 0 ? void 0 : pagination.total) || 999999),
        loader: props.dataSource.length > 0 && /*#__PURE__*/React.createElement(Skeleton, {
          avatar: true,
          paragraph: {
            rows: 1
          },
          active: true,
          className: "".concat(prefix, "scroll-skeleton")
        }),
        scrollableTarget: scrollListId
      }, /*#__PURE__*/React.createElement(List, _extends({}, others, {
        renderItem: _renderItem
      }), emptyDom))), _footer && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "scroll-footer-wrap")
      }, _footer));
    }
    return /*#__PURE__*/React.createElement(List, _extends({}, others, {
      renderItem: _renderItem,
      header: header,
      footer: _footer
    }), emptyDom);
  }, [props, _renderItem, _footer]);
  return /*#__PURE__*/React.createElement(Row, {
    gutter: gutter,
    style: style,
    className: "".concat(prefix, "record-view")
  }, /*#__PURE__*/React.createElement(Col, {
    span: _leftSpan
  }, list), !detailModalDisplay && /*#__PURE__*/React.createElement(Col, {
    span: rightSpan
  }, detail), detailModalShow && detailModalDisplay && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "detail-modal-wrap")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "modal-header")
  }, /*#__PURE__*/React.createElement(CloseOutlined, {
    className: "".concat(prefix, "close-icon"),
    onClick: function onClick() {
      return setDetailModalShow(false);
    }
  })), detail));
};
export default RecordView;